// $Id: layout.cc,v 1.2 2002/09/16 09:15:41 christof Exp $
/*  glade--: C++ frontend for glade (Gtk+ User Interface Builder)
 *  Copyright (C) 1998  Christof Petig
 *  Copyright (C) 1999-2000 Adolf Petig GmbH & Co. KG, written by Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "container.hh"

class Gtk_Layout : public Gtk_Container
{public:
	typedef Gtk_Container Parent;
	virtual const std::string TypeName(const Widget &w) const;
	virtual const std::string IncludeName(const Widget &w) const;
	Gtk_Layout();
	void AddChild(const Widget &w,CxxFile &f,const std::string &instance) const;
	virtual bool NeedExplicitCtor(const Widget &w) const
	{  return false; }
	virtual void ConstructionArgs(Widget const &w, CxxFile &f) const
	{  f.FunctionArg(); }
//	void ConfigureChildren(CxxFile &f,const Widget &w,const std::string &instance) const;
	virtual void Configure(const Widget &w,CxxFile &f,const std::string &instance) const;
};

static Gtk_Layout Gtk_Layout;

const std::string Gtk_Layout::TypeName(const Widget &w) const
{  return GtkPrefix()+"Layout";
}

const std::string Gtk_Layout::IncludeName(const Widget &w) const
{  return Configuration.GtkmmIncludePath()+"layout.h";
}

Gtk_Layout::Gtk_Layout()
{  Writer["GtkLayout"]=this;
}

void Gtk_Layout::AddChild(const Widget &w,CxxFile &f,const std::string &instance) const
{  int x=w.getIntProperty("x",0);
   int y=w.getIntProperty("y",0);
   f.Statement() << instance << "put" << '(' 
     << Reference(w) << ", " << x << ", " << y << ')';
}

void Gtk_Layout::Configure(const Widget &w,CxxFile &f,const std::string &instance) const
{  Parent::Configure(w,f,instance);
   int x=w.getIntProperty("area_width",200);
   int y=w.getIntProperty("area_height",200);
   f.Statement() << instance << "set_size(" << x << ", " << y << ')';
   // hstep/vstep --> ????
}
